diff --git a/dprint.c b/dprint.c
index ae9f5f8ef1..53cf78339d 100644
--- a/dprint.c
+++ b/dprint.c
@@ -36,6 +36,9 @@
 
 static int log_level_holder = L_NOTICE;
 
+/* shared holder with the globally set log_level */
+static int *log_level_global = NULL;
+
 /* current logging level for this process */
 int *log_level = &log_level_holder;
 
@@ -96,9 +99,20 @@ void dprint(char * format, ...)
 int init_log_level(void)
 {
 	log_level = &pt[process_no].log_level;
-	*log_level = log_level_holder;
 	default_log_level = &pt[process_no].default_log_level;
-	*default_log_level = log_level_holder;
+
+	if (process_no==0) {
+		/* this is done only by the first process */
+		log_level_global = (int*)shm_malloc(sizeof(int));
+		if (log_level_global==NULL) {
+			LM_ERR("Failed to allocate shm memory for global log_level\n");
+			return -1;
+		}
+		*log_level_global = log_level_holder;
+	}
+
+	*log_level = *log_level_global;
+	*default_log_level = *log_level_global;
 
 	return 0;
 }
@@ -142,6 +156,7 @@ void set_global_log_level(int level)
 		__set_proc_default_log_level(i, level);
 		__set_proc_log_level(i, level);
 	}
+	*log_level_global = level;
 }
 
 /* set the log level of the current process */
